do
    local void_scale_factor = 10
    local fluid_wagon_capacity_multiplier = 4
    local fluid_storage_capacity_multiplier = 2

    local function make_furnace_assembling_machines(name)
        furnace = data.raw.furnace[name]
        furnace.type = "assembling-machine"
        data.raw["assembling-machine"][furnace.name] = furnace
        data.raw.furnace[name] = nil
    end

    local function make_voiders_assembling_machines()
        for _, r in pairs(data.raw.recipe) do
            if r.subgroup == "py-void-gas" then
                r.results[1].type = "item"
                r.results[1].name = "py-gas-vent"
            elseif r.subgroup == "py-void-liquid" then
                r.results[1].type = "item"
                r.results[1].name = "py-sinkhole"
            end
        end

        make_furnace_assembling_machines("py-sinkhole")
        make_furnace_assembling_machines("py-gas-vent")
        make_furnace_assembling_machines("py-burner")
    end

    local function is_fluid_void(recipe)
        return recipe.subgroup == "py-void-gas" or recipe.subgroup == "py-void-liquid"
    end

    local function improve_voiding_ups()
        for _, r in pairs(data.raw.recipe) do
            if is_fluid_void(r) then
                r.energy_required = (r.energy_required or 0.5) * void_scale_factor
                r.ingredients[1].amount = r.ingredients[1].amount * void_scale_factor
            end
        end
    end

    local function increase_fluid_wagon_capacity()
        for _, w in pairs(data.raw["fluid-wagon"]) do
            w.capacity = w.capacity * fluid_wagon_capacity_multiplier
        end
    end

    local function increase_fluid_storage_capacity()
        for _, t in pairs(data.raw["storage-tank"]) do
            local capacity = t.fluid_box.base_area
            t.fluid_box.base_area = capacity * fluid_storage_capacity_multiplier
        end
    end

    --improve_voiding_ups()
    --increase_fluid_wagon_capacity()
    --increase_fluid_storage_capacity()
    make_voiders_assembling_machines()
end